From 52f07ff3eef3016e0a408e476d1567e34561d5bf Mon Sep 17 00:00:00 2001
From: Claude Heiland-Allen <claude@mathr.co.uk>
Date: Sun, 23 Sep 2018 21:54:55 +0100
Subject: [PATCH 25/39] perform visibility checks in displace, select, delete

as per katjav's comment:
https://github.com/pure-data/pure-data/commit/418428350f6a3f4aebf8b378dbefea39c38b4ee5#commitcomment-30609923
---
 src/classes_gui.cxx | 21 ++++++++++++++-------
 1 file changed, 14 insertions(+), 7 deletions(-)

diff --git a/src/classes_gui.cxx b/src/classes_gui.cxx
index f3820c50..f080ff8e 100644
--- a/src/classes_gui.cxx
+++ b/src/classes_gui.cxx
@@ -96,18 +96,25 @@ public:
 	}
 	static void displacefn(BLAH, int dx, int dy) {INIT L
 		bself->te_xpix+=dx; bself->te_ypix+=dy;
-		sys_vgui(".x%lx.c move %s %d %d\n",(long)(intptr_t)glist_getcanvas(glist),self->rsym->s_name,dx,dy);
-		canvas_fixlinesfor(glist, (t_text *)x);
+		if (glist_isvisible(glist))
+		{
+			sys_vgui(".x%lx.c move %s %d %d\n",(long)(intptr_t)glist_getcanvas(glist),self->rsym->s_name,dx,dy);
+			canvas_fixlinesfor(glist, (t_text *)x);
+		}
 	}
 	static void selectfn(BLAH, int state) {INIT L
 		self->selected=!!state;
-		sys_vgui(".x%lx.c itemconfigure {%sR || %sTEXT} -outline %s\n",(long)(intptr_t)c,
-			self->rsym->s_name,self->rsym->s_name,self->selected?"#0000ff":self->outline.data());
+		if (glist_isvisible(glist))
+			sys_vgui(".x%lx.c itemconfigure {%sR || %sTEXT} -outline %s\n",(long)(intptr_t)c,
+				self->rsym->s_name,self->rsym->s_name,self->selected?"#0000ff":self->outline.data());
 	}
 	static void deletefn(BLAH) {INIT L
-		if (self->vis) sys_vgui(".x%lx.c delete %s\n",(long)(intptr_t)c,self->rsym->s_name);
-		canvas_deletelinesfor(glist,(t_object *)bself); // hein ?
-		sys_unqueuegui(x);
+		if (glist_isvisible(glist))
+		{
+			sys_vgui(".x%lx.c delete %s\n",(long)(intptr_t)c,self->rsym->s_name);
+			canvas_deletelinesfor(glist,(t_object *)bself); // hein ?
+			sys_unqueuegui(x);
+		}
 	}
 	static int clickfn(BLAH, int xpix, int ypix, int shift, int alt, int dbl, int doit) {INIT
 		//post("click1 %d %d %d %d %d %d",xpix,ypix,shift,alt,dbl,doit);
-- 
2.19.1

